#version 430
out float FragColor;
in vec2 TexCoords;

uniform sampler2D ssaoInput;
uniform sampler2D positionTex;
uniform sampler2D normTex;
uniform int blurSize =11;

//http://dev.theomader.com/gaussian-kernel-calculator/
//sigma 5
//float kernel[9] = float[9](0.091637,0.105358,0.1164,0.123573,0.126061,0.123573,0.1164,0.105358,0.091637);
float kernel[11] = float[11](0.082756,0.087479,0.091337,0.094197,0.095956,0.09655,0.095956,0.094197,0.091337,0.087479,0.082756);


void main() {
	
	float pixWidth = 1 / (vec2(textureSize(ssaoInput, 0)).x);
	float centerDepth = texture(positionTex, TexCoords).r;
	vec3 centerNorm = texture(normTex, TexCoords).rgb;
    float result = 0.0;
	float weightsum = 0;

	for (int i = -blurSize/2; i<blurSize/2;i++) {
	
		vec2 offset = vec2(pixWidth*i,0);
		vec3 currentNorm = texture(normTex, TexCoords + offset).rgb;
		float currentDepth = texture(positionTex, TexCoords + offset).r;
		if(abs(currentDepth-centerDepth)<0.5&& dot(centerNorm,currentNorm)>0.01){
			
        result += texture(ssaoInput, TexCoords + offset).r * kernel[i+blurSize/2];
		weightsum += kernel[i+blurSize/2];
		}
	}
	
	FragColor =result * (1/weightsum);
}

