#version 430 core

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform mat4 projMatrix;

void main() {

	//for G-Buffer use position and normals in view space
	vec4 position_world_ = viewMatrix * modelMatrix * vec4(position, 1);

	vert.position_world = position_world_.xyz;
	
	mat3 normalMatrix = transpose(inverse(mat3(viewMatrix * modelMatrix)));
	vert.normal_world = normalMatrix * normal;
	
	gl_Position = projMatrix * position_world_;
	
}