#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;

out vec3 eye_vector;
out vec3 normal_world;
out vec3 position_world;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform vec3 camera_world;

void main() {
	normal_world = normalMatrix * normal;
	vec4 position_world_ = modelMatrix * vec4(position, 1);
	position_world = position_world_.xyz;
	eye_vector = normalize(position_world - camera_world);
	gl_Position = viewProjMatrix * position_world_;
}